=== debian/control ===
Source: libmirage
Section: libs
Priority: optional
Homepage: https://cdemu.sourceforge.io/
Maintainer: Matteo Bini <matteobin@tiepi.it>
Build-Depends: cmake (>= 3.16.0),
               debhelper-compat (= 13),
               gtk-doc-tools,
               intltool,
               libbz2-dev,
               liblzma-dev,
               libglib2.0-dev (>= 2.38),
               libsamplerate0-dev,
               libsndfile1-dev,
               pkgconf,
               zlib1g-dev,
               libgcrypt20-dev,
               gobject-introspection (>= 1.80),
               gir1.2-gobject-2.0-dev,
               gir1.2-gio-2.0-dev,
               gir1.2-gmodule-2.0-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no


Package: libmirage12
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libmirage9, libmirage10, libmirage11
Replaces: libmirage9, libmirage10, libmirage11
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: CD-ROM image access library
 This is libMirage library, a CD-ROM image access library, and part of the
 CDEmu suite, a free, GPL CD/DVD-ROM device emulator for Linux. It is
 written in C and based on GLib.
 .
 The aim of libMirage is to provide uniform access to the data stored in
 different image formats, by creating a representation of disc stored in image
 file, which is based on GObjects.


Package: gir1.2-mirage-3.2
Section: introspection
Architecture: any
Multi-Arch: same
Conflicts: gir1.2-mirage-3.1
Replaces: gir1.2-mirage-3.1
Depends: libmirage12 (= ${binary:Version}), ${gir:Depends}, ${misc:Depends}
Description: CD-ROM image access library (typelib files)
 libMirage is a CD-ROM image access library, part of the CDEmu suite,
 a free, GPL CD/DVD-ROM device emulator for Linux.
 .
 This package provides typelib files.


Package: libmirage-dev
Section: libdevel
Architecture: any
Provides: ${gir:Provides}
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${gir:Depends},
         gir1.2-mirage-3.2 (= ${binary:Version}),
         libmirage12 (= ${binary:Version})
Description: CD-ROM image access library development files
 libMirage is a CD-ROM image access library, part of the CDEmu suite,
 a free, GPL CD/DVD-ROM device emulator for Linux.
 .
 This package contains the files needed to compile and link programs which
 use libMirage.


Package: libmirage-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: devhelp
Multi-Arch: foreign
Description: Reference manual for libMirage
 libMirage is a CD-ROM image access library, part of the CDEmu suite,
 a free, GPL CD/DVD-ROM device emulator for Linux.
 .
 This package contains the reference manual.
