=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#export DH_VERBOSE=1


override_dh_auto_configure:
	dh_auto_configure -- \
		-DPOST_INSTALL_HOOKS:BOOL=OFF \
		-DGTKDOC_ENABLED=$(if $(filter libmirage-doc,$(shell dh_listpackages)),ON,OFF)

override_dh_makeshlibs:
	dh_makeshlibs --exclude="libmirage-3.3"

override_dh_shlibdeps:
	dh_shlibdeps --exclude="libmirage-3.3"

%:
	dh $@ --with gir
